package com.jiuqi.util.chinese;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.util.chinese.NoValidCharException;

public class StringSplitor {
  private final char[] CHARS;
  
  private int position;
  
  private int nextPosition;
  
  private final char[] EXCLUDE_SET;
  
  public StringSplitor(String value, char[] excludSet) {
    if (value != null) {
      this.CHARS = value.toCharArray();
      this.position = -1;
      this.nextPosition = -1;
      this.EXCLUDE_SET = excludSet;
    } else {
      throw new IllegalArgumentException("指向空的字符串指针！");
    } 
  }
  
  public boolean isValidChar(char theChar) {
    boolean found = false;
    for (int i = 0; i < this.EXCLUDE_SET.length; i++) {
      if (this.EXCLUDE_SET[i] == theChar) {
        found = true;
        break;
      } 
    } 
    return !found;
  }
  
  public boolean hasValidChar() {
    if (this.position == this.CHARS.length - 1)
      return false; 
    if (this.nextPosition > this.position)
      return true; 
    for (int i = this.position + 1; i < this.CHARS.length; i++) {
      char thisChar = this.CHARS[i];
      if (isValidChar(thisChar)) {
        this.nextPosition = i;
        return true;
      } 
    } 
    return false;
  }
  
  public char getNextValidChar() throws NoValidCharException {
    if (hasValidChar()) {
      this.position = this.nextPosition;
      return this.CHARS[this.position];
    } 
    throw new NoValidCharException("这个字符串已经没有非空格的字符！");
  }
  
  public void rollBack() {
    boolean found = false;
    int prePosition;
    for (prePosition = this.position - 1; prePosition >= 0; prePosition--) {
      if (isValidChar(this.CHARS[prePosition])) {
        found = true;
        break;
      } 
    } 
    if (found) {
      this.position = prePosition;
    } else {
      this.position = -1;
    } 
    this.nextPosition = this.position;
  }
  
  public String getLeft() {
    return new String(this.CHARS, this.position + 1, 
        this.CHARS.length - this.position - 1);
  }
  
  public int validLength() {
    int length = 0;
    for (int i = 0; i < this.CHARS.length; i++) {
      if (isValidChar(this.CHARS[i]))
        length++; 
    } 
    return length;
  }
}
